function trans()


require "import"
import "android.net.Uri"
import "android.text.Html"
import "com.androlua.Http"
import "java.util.Locale"


service.getEditText()
text= service.getLastSpeakText()
local language = "english"
local defaultLanguage = Locale.getDefault().getLanguage()
local languageCodes = { ["english"] = "en" }  

local languageCode = languageCodes[language]
if languageCode then
    local wordsToTranslate = text
    local translatedWords = ""
    
    local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
    url = url .. "&tl=" .. languageCode
    
    Http.get(url, function(status, result)
        if status == 200 then
            translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
            translatedWords = Html.fromHtml(translatedWords).toString()
            service.paste(translatedWords .. ". ")
            
            this.speak(translatedWords)
        end
    end)
end
end
-- الٱملاء الصوتي من google. يدعم اللغة العربية و الأنجليزية في نفس الوقت
-- يجب منح الجيشو ٱذن الميكروفون

-- Import necessary AndroLua classes for Android interaction
local luajava = require("luajava")
local Context = luajava.bindClass("android.content.Context")
local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
local Intent = luajava.bindClass("android.content.Intent")
local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
local Activity = luajava.bindClass("android.app.Activity")

local activity = this

-- Function to start voice recognition with Arabic language
function startVoiceRecognition(activity)

    local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    
    -- Set the language to Arabic
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ta-TA") -- Use "ar-SA" for Saudi Arabian Arabic, you can adjust it as needed

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
        onReadyForSpeech = function(params)
            -- Handle the ready for speech event
        end,
        onResults = function(params)
            local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            -- Handle the recognized speech results
            -- You can display or use the recognized text here
            this.postSpeak(500,results.get(0)) -- Display the first recognized result in the EditText
service.postClick(700,{{"%trans"}})
        end,
        -- Handle other recognition events here
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
end

    startVoiceRecognition(activity)

-- Called when the activity is created
function onCreate(savedInstanceState)
    activity.setTitle("Voice Input Example")
end

service.click({"يمكنك كتابة نص هنا لترجمته*@*", "#com.google.android.inputmethod.latin:id/0_resource_name_obfuscated",})